#include "kitt_voice_values.lua"
#include "kitt_constants.lua"

function init()
	-- kittSounds = {
	-- 	["hello"]= { LoadSound("MOD/kitt/snd/kitt_hello.ogg"), {0} };
	-- 	["intro"]= { LoadSound("MOD/kitt/snd/kitt_intro.ogg"), {0} };
	-- 	["deny"]= { LoadSound("MOD/kitt/snd/kitt_deny.ogg"), {0} };
	-- 	["rnd01"]= { LoadSound("MOD/kitt/snd/kitt_rnd01.ogg"), {0} };
	-- 	["karr_intro"]= { LoadSound("MOD/kitt/snd/karr_intro.ogg"), {0} };
	-- }

	kittSoundsUi = {
		["hello"]= { "MOD/kitt/snd/kitt_hello.ogg" };
		["intro"]= { "MOD/kitt/snd/kitt_intro.ogg" };
		["deny"]= { "MOD/kitt/snd/kitt_deny.ogg" };
		["rnd01"]= { "MOD/kitt/snd/kitt_rnd01.ogg" };
		["karr_intro"]= { "MOD/kitt/snd/karr_intro.ogg" };
		["music_dialog"]= { "MOD/kitt/snd/kitt_music_dialog.ogg" };
		["music_question"]= { "MOD/kitt/snd/kitt_music_question.ogg" };
		["autoroof_l_hint"]= { "MOD/kitt/snd/kitt_autoroof_l_hint.ogg" };
	}
	scannerSound = LoadSound("MOD/kitt/snd/kitt_scanner")
	helloSound = LoadSound("MOD/kitt/snd/kitt_hello")
	denySound = LoadSound("MOD/kitt/snd/kitt_deny")
	-- doorSound = LoadSound("doors.ogg")
	-- helloSound = LoadSound("MOD/kitt/snd/kitt_wall_hit")
	local scanner_ids = {
		"scanner_seg1";
		"scanner_seg2";
		"scanner_seg3";
		"scanner_seg4";
		"scanner_seg5";
		"scanner_seg6";
		"scanner_seg7"
	}
	-- Bodies and shapes
	kittBody = FindBody("kitt_body")
	kittVehicle = FindVehicle("kitt_vehicle")
	kittScreenMainBody = FindBody("kitt_screen_main_body")
	ttopRightShape = FindShape("ttop_right")
	ttopLeftShape = FindShape("ttop_left")
	kittButtonRolloverProtection = FindShape("kitt_rollover_protection_button")

	
	-- KITT_GLOBAL_VUMETER_LEVEL = "rv.kitt.vumeter.level"
	-- KITT_GLOBAL_SPEEDOMETER_VALUE = "rv.kitt.speedometer.value"
	kittInstanceId = GetBodyVehicle(kittBody)
	
	kittInstanceBodyMass = GetBodyMass(kittBody)
	-- DebugPrint("kitt"..kittInstanceId.."mass " .. kittInstanceBodyMass) -- it works in init luckily

	if GetBool("savegame.mod.debugmode") then
		DebugWatch("kitt_vehicle_instance_id", kittInstanceId)
	end
	
	-- strings
	kittTTopLeftOpenString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_JOINT_TTOP_LEFT .. KITT_GLOBAL_JOINT_ACTIVE
	kittTTopRightOpenString	= KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_JOINT_TTOP_RIGHT .. KITT_GLOBAL_JOINT_ACTIVE
	kittSilentModeString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SILENT_MODE
	kittEjectLeftActiveString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_EJECT_L .. KITT_GLOBAL_ACTIVE
	-- these don't require initialization
	kittPlaySoundFileString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_PLAY_SOUND_FILE
	kittPlaySoundVuTypeString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_PLAY_SOUND_VUMETER_TYPE

	SetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL, 0.0)
	SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_TYPE, 1)
	SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SPEEDOMETER_VALUE, 0)
	SetString(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_ENGINE_MODE, KITT_GLOBAL_ENGINE_MODE_NORMAL)
	SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SCREEN_TV_LEFT .. KITT_GLOBAL_SCREEN_MODE, KITT_GLOBAL_SCREEN_MODE_OVERVIEW)
	-- SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SCREEN_TV_LEFT .. KITT_GLOBAL_SCREEN_MODE, KITT_GLOBAL_SCREEN_MODE_MUSIC) -- for development (testing)
	SetBool(kittTTopLeftOpenString, false)
	SetBool(kittTTopRightOpenString, false)
	SetBool(kittSilentModeString, false)
	SetBool(kittEjectLeftActiveString, false)

	-- joints
	ttopRightJoint = FindJoint("ttop_right_joint")
	ttopLeftJoint = FindJoint("ttop_left_joint")
	kittLightRightJoint = FindJoint("kitt_light_right_joint")
	kittLightLeftJoint = FindJoint("kitt_light_left_joint")
	
	-- lights
	kittLightRightLight = FindLight("kitt_light_right_light")
	kittLightLeftLight = FindLight("kitt_light_left_light")
	kittLightRightShape = FindShape("kitt_light_right")
	kittLightLeftShape = FindShape("kitt_light_left")

	-- locations
	-- kittDriverLocation = FindLocation("player")
	kittDriverOffset = {0,0,0}

	-- Lightbar stuff
	scanner_lights = {}
	for i=1, #scanner_ids do
		scanner_lights[i] = FindShape(scanner_ids[i])
	end
	--GetShapeWorldTransform
	lightbarBody = FindShape("scanner_seg4")
	-- lightbarBodyTransform = GetBodyTransform(lightbarBody)
	lightbarBodyTransform = GetShapeWorldTransform(lightbarBody)

	-- scanner variables
	lightbar_enabled = false
	-- lightbar_counter = 0
	lightbar_current = 1
	lightbar_t = 0
	lightbar_dir_forward = true
	-- SetString("hud.notification", #scanner_lights)
	lastState_driven = false

	kittHelloTimer = 0
	rolloverProtectionTimer = 0
	kittIntroFinished = false

	kittFrontLightsActive = false
	kittVoiceTimer = 0
	kittVoiceActive = false
	kittVoiceFile = "intro"
	kittStartSoundPlayback = false
	kittScreenControlsActivationInitialized = false
	kittSoundDenyLock = false

	-- Taken straight from speedometer
	-- Actual current speed
	currentKmh = 0	
	-- Displayed speed (smoothly animated)
	displayKmh = 0
	-- End of speedometer code

	-- wheel thrusters
	kitt_wheel_bl_pos = {-0.64999, -0.0, 1.1}
	kitt_wheel_br_pos = {0.65001, -0.0, 1.1}
	kitt_wheel_fl_pos = {-0.64999, -0.0, -1.3}
	kitt_wheel_fr_pos = {0.65001, -0.0, -1.3}
	
	KITT_THRUSTER_GRIP_KEY = "ctrl"
	KITT_THRUSTER_PURSUIT_MODE_KEY = "P"

	KITT_THRUSTER_TOP_LEFT_KEY = "Y"
	KITT_THRUSTER_TOP_RIGHT_KEY = "U"
	KITT_THRUSTER_BOTTOM_LEFT_KEY = "H"
	KITT_THRUSTER_BOTTOM_RIGHT_KEY = "J"
	KITT_BOOSTER_KEY = "shift"
	KITT_CONTROLS_KEY = "C"
	
	kitt_thruster_top_left_active = false
	kitt_thruster_top_right_active = false
	kitt_thruster_bottom_left_active = false
	kitt_thruster_bottom_right_active = false

	kitt_thruster_grip_toggle_active = false
	kitt_thruster_grip_active = false

	kitt_booster_active = false
	kitt_retrobooster_active = false

	kittEjectionVector = {0,0,0}

	backupGlobalFov = GetInt("options.gfx.fov")
	globalFov = GetInt("options.gfx.fov")
	globalScreenW = 1
	globalScreenH = 1
	globalScreenRatio = 1
	kittControlPanelLookAngle = -5 -- computed according to the aspect ratio
	globalScreenInfoInitialized = false
end

function tick(dt)
	-- DebugWatch
	-- DebugPrint
	-- DebugLine
	-- DebugCross
	if GetBool("savegame.mod.debugmode") then
		-- DebugWatch("dt", dt)
		
		-- DebugWatch("kittVoiceActive", kittVoiceActive)
		-- DebugWatch("kittVoiceFile", kittVoiceFile)
		-- DebugWatch("kittVoiceTimer", kittVoiceTimer)
		-- DebugWatch("globalKittVuMeter", GetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL))

		-- DebugWatch("kittBody", kittBody)
		-- DebugWatch("testGlobalVar", KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL)
		DebugWatch("kitt"..kittInstanceId.."Mass", GetBodyMass(kittBody))
		-- DebugWatch("kittMass", GetBodyMass(GetVehicleBody(FindVehicle("kitt"))))
	end
	-- kittVoiceTimer = kittVoiceTimer + dt
	-- KITT voice handling
	if kittVoiceActive then
		kittVoiceTimer = kittVoiceTimer + dt
		if kittVoiceTimer > (#kittVoiceValues[kittVoiceFile] * 0.1) then 
			kittVoiceActive = false
			SetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL, 0.0) -- TODO: change to 0.0 once you sort this out
			if GetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_TYPE) == 3 then
				SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_TYPE, 1)
			end
		else
			local temp_index = 1 + math.floor(kittVoiceTimer * 10)
			-- DebugWatch("vu_array", temp_index)
			local temp_level = kittVoiceValues[kittVoiceFile][temp_index]
			-- DebugWatch("vu_level", temp_level)
			SetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL, temp_level)
		end
	end
	
	-- external voice handling
	local tempPlaySoundFile = GetString(kittPlaySoundFileString)
	if tempPlaySoundFile ~= "" then
		local tempVuType = GetInt(kittPlaySoundVuTypeString)
		if tempVuType ~= 0 then
			kittPlaySound(tempPlaySoundFile, tempVuType)
		else
			kittPlaySound(tempPlaySoundFile)
		end
		SetString(kittPlaySoundFileString)
		SetInt(kittPlaySoundVuTypeString, 0)
	end

	-- print("KITT print function test")
	-- reset lights because they're automatically set each frame if you're in the vehicle
	for i=1, #scanner_lights do
		if i ~= lightbar_current then
			SetShapeEmissiveScale(scanner_lights[i], 0)
		end
	end
	
	if (GetPlayerInteractShape() == kittButtonRolloverProtection and InputPressed("interact")) or (GetPlayerVehicle() == kittInstanceId and InputPressed("r")) then
		-- DebugPrint("Rollover Protection activated")
		-- SetString("hud.notification","Rollover Protection activated")
		if not kittSoundDenyLock then
			kittSoundDenyLock = true
			kittPlaySound("deny")
		end
		rolloverProtectionTimer = 20
	end
	
	if (GetPlayerInteractShape() == kittLightRightShape or GetPlayerInteractShape() == kittLightLeftShape) and InputPressed("interact") then
		if GetBool("savegame.mod.debugmode") then
			DebugPrint("Front lights toggled")
		end
		kittFrontLightsActive = not kittFrontLightsActive 
	end
	
	if HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputPressed("f") then
		kittFrontLightsActive = not kittFrontLightsActive
	end

	-- Taken straight from speedometer
	--Retrieve speed along forward direction (negative z axis) in local vehicle body transform
	-- local b = GetVehicleBody(v)
	-- local t = GetVehicleTransform(v)
	local vel = TransformToLocalVec(GetBodyTransform(kittBody), GetBodyVelocity(kittBody))
	local speed = -vel[3]
	--Speed is in meter per second, convert to km/h
	currentKmh = speed * 3.6
	-- End of speedometer code

	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputPressed(KITT_THRUSTER_PURSUIT_MODE_KEY)) then
		kitt_thruster_grip_toggle_active = not kitt_thruster_grip_toggle_active
	end

	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown(KITT_THRUSTER_GRIP_KEY))  then
		kitt_thruster_grip_active = true
	else
		kitt_thruster_grip_active = false
	end
	
	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown(KITT_THRUSTER_TOP_LEFT_KEY)) then
		kitt_thruster_top_left_active = true
	else
		kitt_thruster_top_left_active = false
	end
	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown(KITT_THRUSTER_TOP_RIGHT_KEY)) then
		kitt_thruster_top_right_active = true
	else
		kitt_thruster_top_right_active = false
	end
	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown(KITT_THRUSTER_BOTTOM_LEFT_KEY)) then
		kitt_thruster_bottom_left_active = true
	else
		kitt_thruster_bottom_left_active = false
	end
	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown(KITT_THRUSTER_BOTTOM_RIGHT_KEY)) then
		kitt_thruster_bottom_right_active = true
	else
		kitt_thruster_bottom_right_active = false
	end

	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown(KITT_BOOSTER_KEY) and InputDown("w")) then
		kitt_booster_active = true
		-- DebugPrint("BOOSTER")
	else
		kitt_booster_active = false
	end
	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown(KITT_BOOSTER_KEY) and InputDown("s")) then
		kitt_retrobooster_active = true
		-- DebugPrint("RETROBOOSTER")
	else
		kitt_retrobooster_active = false
	end
	
	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown("b")) then
		SetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL, 0.0)
		DebugPrint("") -- clears "console"
	end
	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown("n")) then
		SetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL, 0.55)
	end
	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputDown("m")) then
		SetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL, 1.0)
	end
	
	if HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputPressed("i") then
		kittPlaySound("intro", 1)
	end

	-- if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputPressed("p")) then
	-- 	kittPlaySound("rnd01", 3)
	-- end

	if (HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and InputPressed("o")) then
		kittPlaySound("karr_intro", 2)
	end
	
	-- DebugWatch('resolution', GetInt("options.display.resolution"))
	-- DebugWatch('resolution', globalScreenW .. "x" .. globalScreenH .. " ratio: " .. globalScreenRatio .. " control panel look angle: " .. kittControlPanelLookAngle)
	if (GetPlayerVehicle() == kittInstanceId) and InputDown(KITT_CONTROLS_KEY) then
		if not kittScreenControlsActivationInitialized then
			kittScreenControlsActivationInitialized = true
			kittDriverOffset = VecSub(GetCameraTransform().pos, GetVehicleTransform(GetPlayerVehicle()).pos)
		end
		local vehtf = GetVehicleTransform(GetPlayerVehicle())
		-- TODO: Can't get it all to work properly
		-- local playerpos = TransformToParentPoint(GetBodyTransform(kittBody), {0.35, 0.75, -0.15}) -- player pos read from xml, hardcoded
		-- local playerpos = TransformToParentPoint(GetVehicleTransform(GetPlayerVehicle()), {0.35, 0.75, -0.15}) -- player pos read from xml, hardcoded
		-- local playerpos = TransformToParentPoint(GetBodyTransform(kittBody), {-0.30, 0.6, -0.1}) -- player pos fixed, best before the next solution
		local playerpos = TransformToParentPoint(GetVehicleTransform(GetPlayerVehicle()), GetVehicleDriverPos(GetPlayerVehicle()))
		-- DebugCross(playerpos, 1, 1, 1)
		SetCameraTransform(Transform(playerpos, QuatRotateQuat(vehtf.rot, QuatEuler(kittControlPanelLookAngle,0,0))), 90)
		SetPlayerScreen(GetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SCREEN_CONTROLS))
		
		-- DebugWatch("screen_active"..kittInstanceId, "true")
	elseif (GetPlayerVehicle() == kittInstanceId) and GetPlayerScreen() == GetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SCREEN_CONTROLS) and not InputDown(KITT_CONTROLS_KEY) then
		kittScreenControlsActivationInitialized = false
		SetPlayerScreen(0)
		-- DebugWatch("screen_active"..kittInstanceId, "false")
	end

	if GetBool(kittEjectLeftActiveString) and GetPlayerVehicle() == kittInstanceId then
		new_v, new_lv = getEjectionVector()
		local vehiclePlayerPos = TransformToParentPoint(GetVehicleTransform(GetPlayerVehicle()), GetVehicleDriverPos(GetPlayerVehicle()))
		local crossPos = VecAdd(vehiclePlayerPos, new_v)
		DebugCross(crossPos, 1,0.3,0.3,1)
		kittEjectionVector = new_v
	end

	-- DebugWatch('fov',GetInt("options.gfx.fov"))
	-- if globalFov >= 120 then
	-- 	globalFov = 70
	-- else
	-- 	globalFov = globalFov + 1
	-- end
	-- SetInt("options.gfx.fov", globalFov)

	-- GetString("game.mod") ~= ""
	-- DebugWatch("game.levelid", GetString("game.levelid"))
	-- DebugWatch("game.levelpath", GetString("game.levelpath"))
	-- DebugWatch("game.mod", GetString("game.mod"))
	-- DebugWatch("game.mod.title", GetString("game.mod.title"))
	-- DebugWatch("game.mod.description", GetString("game.mod.description"))
	-- DebugWatch("game.mod.path", GetString("game.mod.path"))
	-- DebugWatch("mod path", GetString("mods.available.".. GetString("game.mod") ..".path"))
	-- DebugWatch("music path", GetString("mods.available.".. GetString("game.mod") ..".path").."/kitt/custom_music")
	-- local mods = ListKeys("mods.available")
	-- for i=1, #mods do
	-- 	DebugPrint(mods[i])
	-- end

end

function kittPlaySound(soundName, vuType)
	-- local soundToPlay = kittSounds[soundName]
	-- SetString("hud.notification", #soundToPlay)
	kittVoiceTimer = 0
	kittVoiceActive = true
	kittVoiceFile = soundName
	kittStartSoundPlayback = true
	if vuType then
		-- DebugPrint(vuType)
		SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_TYPE, vuType)
	end
	-- PlaySound(soundToPlay[1]) -- results in muffled sound in cabin
end

function update(dt)
	if HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId and lastState_driven == false then
		-- SetString("hud.notification", "OnVehicleEnter")
		kittHelloTimer = 90
	end

	if kittHelloTimer > 0 then
		kittHelloTimer = kittHelloTimer -1
	end

	if kittHelloTimer == 0 then
		if HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId then
			if kittIntroFinished then
				kittPlaySound("hello")
			else
				kittIntroFinished = true
				kittPlaySound("intro")
				SetString("hud.notification", "I suggest turning Pursuit mode ["..KITT_THRUSTER_PURSUIT_MODE_KEY.."] key while driving, for now at least")
			end
		end
		kittHelloTimer = -1
	end

	-- DebugWatch("playervel", GetPlayerVelocity())

	if lastState_driven and GetPlayerVehicle() == 0 then
		-- SetString("hud.notification", "OnVehicleExit")
		if GetBool(kittEjectLeftActiveString) then
			-- borrowed from Jetpack example mod
			-- TODO: add eject vector and power selection screen
			
			-- local t = GetCameraTransform()
			-- local d = TransformToParentVec(t, Vec(0, 0.16 * 150, 0))
			
			local d = VecScale(VecNormalize(kittEjectionVector), 0.16 * 150)
			local vel = GetPlayerVelocity()
			vel = VecAdd(vel, d)
			SetPlayerVelocity(vel)
			-- DebugWatch("playervel",GetPlayerVelocity())
			-- kitt_eject_left_active = false
			SetBool(kittEjectLeftActiveString, false)
		end
		-- kittHelloTimer = 90
	end

	lastState_driven = HasTag(GetPlayerVehicle(),"kitt_vehicle") and GetPlayerVehicle() == kittInstanceId
	
	-- Lightbar / Scanner
	lightbar_t = lightbar_t + 1
	if lightbar_t > 5 then
		lightbarBodyTransform = GetShapeWorldTransform(lightbarBody)
		lightbar_t = 0
		if lightbar_dir_forward then
			if lightbar_current + 1 > #scanner_lights then
				lightbar_dir_forward = false
				lightbar_current = lightbar_current - 1
			else
				lightbar_current = lightbar_current + 1
			end
		else
			if lightbar_current - 1 < 1 then
				lightbar_dir_forward = true
				lightbar_current = lightbar_current + 1
				if GetBool("game.player.usevehicle") and lastState_driven and not GetBool(kittSilentModeString) then
					PlaySound(scannerSound, lightbarBodyTransform.pos, 0.5)
				end
			else
				lightbar_current = lightbar_current - 1
			end
		end
		SetShapeEmissiveScale(scanner_lights[lightbar_current], 1)
	end

	-- Rollover Protection
	if rolloverProtectionTimer > 0 then
		rolloverProtectionTimer = rolloverProtectionTimer - 1
		
		tf = GetBodyTransform(kittBody)
        tf.pos[2] = tf.pos[2] + 0.1
		-- tf.rot[2] = tf.rot[2] + 0.2
		tf.rot = QuatRotateQuat(tf.rot, QuatEuler(0, 0, 10))
        SetBodyTransform(kittBody, tf)
	end
	
	-- front lights
	if GetJointMovement(kittLightRightJoint) > 85 then
		SetShapeEmissiveScale(kittLightRightShape, 1)
	else
		SetShapeEmissiveScale(kittLightRightShape, 0)
	end
	if GetJointMovement(kittLightLeftJoint) > 85 then
		SetShapeEmissiveScale(kittLightLeftShape, 1)
	else
		SetShapeEmissiveScale(kittLightLeftShape, 0)
	end
	
	kittLightsMotorSpeed = 5
	if kittFrontLightsActive then
		-- finally a solution that gets rid of prop shaking, sadly
		SetJointMotorTarget(kittLightRightJoint, 90, kittLightsMotorSpeed)
		SetJointMotorTarget(kittLightLeftJoint, 90, kittLightsMotorSpeed)
	else
		SetJointMotorTarget(kittLightRightJoint, 0, kittLightsMotorSpeed)
		SetJointMotorTarget(kittLightLeftJoint, 0, kittLightsMotorSpeed)
	end

	-- DebugWatch("leftstring"..kittInstanceId, kittTTopLeftOpenString)
	if GetBool(kittTTopLeftOpenString) then
		-- DebugWatch("leftttop"..kittInstanceId, GetBool(kittTTopLeftOpenString))
		SetJointMotorTarget(ttopLeftJoint, 90, 5)
	else
		-- DebugWatch("leftttop"..kittInstanceId, GetBool(kittTTopLeftOpenString))
		SetJointMotorTarget(ttopLeftJoint, 0, 5)
	end
	
	if GetBool(kittTTopRightOpenString) then
		-- DebugWatch("rightttop"..kittInstanceId, GetBool(kittTTopRightOpenString))
		SetJointMotorTarget(ttopRightJoint, 90, 5)
	else
		-- DebugWatch("rightttop"..kittInstanceId, GetBool(kittTTopRightOpenString))
		SetJointMotorTarget(ttopRightJoint, 0, 5)
	end

	-- Taken straight from speedometer
	--Smoothly animate the speed and clamp it between 0 and 300
	--Doing this in update means it will be done independent of frame rate
	displayKmh = 0.95*displayKmh + 0.05*currentKmh
	if displayKmh < 0 then 
		displayKmh = 0 
	end
	if displayKmh > 999 then 
		displayKmh = 999 
	end
	--- End of speedometer code
	-- SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SPEEDOMETER_VALUE, displayKmh)
	-- Real K.I.T.T. uses miles...
	displayMph = displayKmh*0.621371
	SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SPEEDOMETER_VALUE, displayMph)
	if GetTagValue(kittVehicle, "cfg") == "ai" then -- elboydo's framework support
		SetString(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_ENGINE_MODE, KITT_GLOBAL_ENGINE_MODE_AUTO)
	elseif displayMph > 60 or kitt_thruster_grip_toggle_active then
		SetString(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_ENGINE_MODE, KITT_GLOBAL_ENGINE_MODE_PURSUIT)
	else
		SetString(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_ENGINE_MODE, KITT_GLOBAL_ENGINE_MODE_NORMAL)
	end

	-- DebugWatch("kitt front thrusters", {kitt_thruster_top_left_active, kitt_thruster_top_right_active})
	-- DebugWatch("kitt rear thrusters", {kitt_thruster_bottom_left_active, kitt_thruster_bottom_right_active})
	-- DebugWatch("kitt FL thruster", kitt_thruster_top_left_active)
	-- DebugWatch("kitt FR thruster", kitt_thruster_top_right_active)
	-- DebugWatch("kitt RL thrusters", kitt_thruster_bottom_left_active)
	-- DebugWatch("kitt RR thrusters", kitt_thruster_bottom_right_active)

	if kitt_booster_active then
		frontBooster(GetPlayerVehicle(), 0.3) -- FIXME: we need to be in the vehicle anyway in the previous check, but I still don't like it.
	end
	if kitt_retrobooster_active then
		frontBooster(GetPlayerVehicle(), -0.3) -- FIXME: we need to be in the vehicle anyway in the previous check, but I still don't like it.
	end

	-- Below is the code mostly in an early dev/test phase, don't mind the bloat and useless copy/paste stuff

	-- Init thruster positions
	local topLeftKittPoint = TransformToParentPoint(GetBodyTransform(kittBody), kitt_wheel_fl_pos)
	local topRightKittPoint = TransformToParentPoint(GetBodyTransform(kittBody), kitt_wheel_fr_pos)
	local bottomLeftKittPoint = TransformToParentPoint(GetBodyTransform(kittBody), kitt_wheel_bl_pos)
	local bottomRightKittPoint = TransformToParentPoint(GetBodyTransform(kittBody), kitt_wheel_br_pos)

	-- for AI driving
	if (kitt_thruster_grip_toggle_active ~= kitt_thruster_grip_active) or GetTagValue(kittVehicle, "cfg") == "ai" then
		local crossColor = {1.0, 0.0, 0.0}
		DebugCross(topLeftKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(topRightKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(bottomLeftKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(bottomRightKittPoint, crossColor[1], crossColor[2], crossColor[3])
		local pos = Vec(0,1,0)
		local imp = Vec(0,calculateThrusterForce(-1000),0)
		ApplyBodyImpulse(kittBody, topLeftKittPoint, imp)
		ApplyBodyImpulse(kittBody, topRightKittPoint, imp)
		ApplyBodyImpulse(kittBody, bottomLeftKittPoint, imp)
		ApplyBodyImpulse(kittBody, bottomRightKittPoint, imp)
	end
	
	
	if kitt_thruster_top_left_active then
		local crossColor = {1.0, 0.0, 0.0}
		DebugCross(topLeftKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(topRightKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(bottomLeftKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(bottomRightKittPoint, crossColor[1], crossColor[2], crossColor[3])
		local pos = Vec(0,1,0)
		local imp = Vec(0,calculateThrusterForce(-1000),0)
		ApplyBodyImpulse(kittBody, topLeftKittPoint, imp)
		ApplyBodyImpulse(kittBody, topRightKittPoint, imp)
		ApplyBodyImpulse(kittBody, bottomLeftKittPoint, imp)
		ApplyBodyImpulse(kittBody, bottomRightKittPoint, imp)
	end

	if kitt_thruster_top_right_active then
		local crossColor = {0.0, 1.0, 0.0}
		DebugCross(topLeftKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(topRightKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(bottomLeftKittPoint, crossColor[1], crossColor[2], crossColor[3])
		DebugCross(bottomRightKittPoint, crossColor[1], crossColor[2], crossColor[3])
		local pos = Vec(0,1,0)
		local imp = Vec(0,calculateThrusterForce(3000),0)
		ApplyBodyImpulse(kittBody, topLeftKittPoint, imp)
		ApplyBodyImpulse(kittBody, topRightKittPoint, imp)
		ApplyBodyImpulse(kittBody, bottomLeftKittPoint, imp)
		ApplyBodyImpulse(kittBody, bottomRightKittPoint, imp)
	end
	if kitt_thruster_bottom_left_active then
		DebugCross(topLeftKittPoint)
		DebugCross(bottomLeftKittPoint)
		local pos = Vec(0,1,0)
		local imp = Vec(0,calculateThrusterForce(1000),0)
		ApplyBodyImpulse(kittBody, topLeftKittPoint, imp)
		ApplyBodyImpulse(kittBody, bottomLeftKittPoint, imp)
	end
	if kitt_thruster_bottom_right_active then
		DebugCross(topRightKittPoint)
		DebugCross(bottomRightKittPoint)
		local pos = Vec(0,1,0)
		local imp = Vec(0,calculateThrusterForce(1000),0)
		ApplyBodyImpulse(kittBody, topRightKittPoint, imp)
		ApplyBodyImpulse(kittBody, bottomRightKittPoint, imp)
	end

	-- moved above, but didn't help with "thruster mutual exclusion"
	-- if kitt_booster_active then
	-- 	frontBooster(GetPlayerVehicle(), 0.3) -- FIXME: we need to be in the vehicle anyway in the previous check, but I still don't like it.
	-- end
	-- if kitt_retrobooster_active then
	-- 	frontBooster(GetPlayerVehicle(), -0.3) -- FIXME: we need to be in the vehicle anyway in the previous check, but I still don't like it.
	-- end
	-- DebugWatch("kitt"..kittInstanceId.."EjectionVector", kittEjectionVector)
end

function frontBooster(v, power)
	-- power = 0.3
	if power > 0 then
		tailPos = 2.4
		velMultiplier = 1
	else
		tailPos = -2.5
		velMultiplier = -1
	end

	-- Borrowed from official "Vehicle booster" example

	--Compute tail point and back direction on vehicle in world space
	local t = GetVehicleTransform(v)
	-- local p = TransformToParentPoint(t, Vec(0, 0.5, 3))
	local p = TransformToParentPoint(t, Vec(0, 0.5, tailPos))
	local d = TransformToParentVec(t, Vec(0, 0, 1))

	--Push the vehicle forwards
	local b = GetVehicleBody(v)	
	local v = GetBodyVelocity(b)
	v = VecAdd(v, VecScale(d, -power))
	SetBodyVelocity(b, v)

	--Engaged particle effects
	local pvel = VecScale(v, 0.7)
	SpawnParticle("fire", p, VecAdd(pvel, VecScale(d, 2 * velMultiplier)), 1.0, 0.5)
	SpawnParticle("smoke", p, VecAdd(pvel, VecScale(d, 5 * velMultiplier)), 1, 3.0)
	SpawnParticle("darksmoke", p, VecAdd(pvel, VecScale(d, 10 * velMultiplier)), 1.5, 1.0)
	
	--Play sound
	-- PlayLoop(snd, t.pos, 0.75)
	-- --Idle particle effect
	-- SpawnParticle("fire", p, VecScale(d, 1), 0.3, 0.1)
	-- SpawnParticle("smoke", p, VecScale(d, 2), 0.5, 1.0)
end

function calculateThrusterForce(force)
	return force * ( kittInstanceBodyMass / KITT_DEFAULT_MASS)
end

function getEjectionVector()
	-- Big thanks to @Thomasims (of Physgun and UMF) for help with this
	view_direction = GetCameraTransform()
	vehicle_transform = GetVehicleTransform(kittVehicle)
	
	v = TransformToParentVec(view_direction, Vec(0,0,-1))
	-- DebugWatch('view_direction', v)
	-- DebugWatch('vehicle_transform',vehicle_transform)

	lv = TransformToLocalVec(vehicle_transform, v)
	-- DebugWatch('lv',lv)

	yaw = math.deg(math.atan2(-lv[1], -lv[3])) -- might have to do some swapping/inverting x & z
	pitch = math.deg(math.asin(lv[2]))
	new_pitch = math.max(60, pitch) -- 70 is the lowest pitch to send at
	new_lv = TransformToParentVec(Transform(Vec(), QuatEuler(new_pitch, yaw, 0)), Vec(0, 0, -1)) -- lotta trial and error to do here
	new_v = TransformToParentVec(vehicle_transform, new_lv)
	return new_v, new_lv
end

function draw()
	-- get screen data once
	if not globalScreenInfoInitialized then
		globalScreenW = UiWidth()
		globalScreenH = UiHeight()
		globalScreenRatio = UiWidth() / UiHeight()
		if globalScreenRatio > 1.78 then -- wider than 16:9
			kittControlPanelLookAngle = -(5 + 7*((globalScreenRatio - 1.78) / (2.39 - 1.78)) ) -- don't ask
		end
		globalScreenInfoInitialized = true
	end

	-- audio handling required to make KITT sound the same no matter the environment
	if kittStartSoundPlayback then
		kittStartSoundPlayback = false
		local soundToPlay = kittSoundsUi[kittVoiceFile]
		UiSound(soundToPlay[1])
	end

	local vehicle = GetPlayerVehicle()
	local boosterKeys = string.upper(KITT_THRUSTER_TOP_LEFT_KEY).." "..string.upper(KITT_THRUSTER_TOP_RIGHT_KEY).." "..string.upper(KITT_THRUSTER_BOTTOM_LEFT_KEY).." "..string.upper(KITT_THRUSTER_BOTTOM_RIGHT_KEY)

	local info = {}
	if HasTag(vehicle, "kitt_vehicle") and GetPlayerVehicle() == kittInstanceId then
		info[#info+1] = {"K.I.T.T.", "Keymap"}
		info[#info+1] = {"Mouse scroll", "First Person"}
		info[#info+1] = {"(zoom in)", "View"}
		if string.lower(KITT_BOOSTER_KEY) == "shift" then
			info[#info+1] = {string.upper(KITT_BOOSTER_KEY).."+"..GetString("game.input.up").."/"..GetString("game.input.down"), "Booster"}
		else
			info[#info+1] = {GetString("game.input.up").."+"..string.upper(KITT_BOOSTER_KEY).."   "..GetString("game.input.down").."+"..string.upper(KITT_BOOSTER_KEY), "Booster"}
		end
		info[#info+1] = {"I O", "VU Meter"}
		info[#info+1] = {"", "Tests"}
		info[#info+1] = {"F", "Front lights"}
		info[#info+1] = {"R", "Z-Flip"}
		-- info[#info+1] = {"", "Protection"}
		info[#info+1] = {string.upper(KITT_THRUSTER_GRIP_KEY).."/"..string.upper(KITT_THRUSTER_PURSUIT_MODE_KEY), "Grip/Toggle"}
		info[#info+1] = {KITT_CONTROLS_KEY, "Control Panel"}
		info[#info+1] = {boosterKeys, "Thrusters"}
		info[#info+1] = {"B    N    M    ", "VU Meter"}
		info[#info+1] = {"0.0 0.5 1.0", "Test values"}

		-- Borrowed from the official UI scripts
		-- WARNING: Mind the "healthFade" from the original scripts, or you will get UI overlap
		UiPush()
		UiAlign("top left")
		local w = 250
		local h = #info*22 + 30
		UiTranslate(UiWidth()-w-20, UiHeight()-h-20 - 200) -- because I don't know how big the official vehicle UI will be
		UiColor(0,0,0,0.5)
		UiImageBox("ui/common/box-solid-6.png", 250, h, 6, 6)
		UiTranslate(125, 32)
		UiColor(1,1,1)
		for i=1, #info do
			local key = info[i][1]
			local func = info[i][2]
			UiFont("bold.ttf", 22)
			UiAlign("right")
			UiText(key)
			UiTranslate(10, 0)
			UiFont("regular.ttf", 22)
			UiAlign("left")
			UiText(func)
			UiTranslate(-10, 22)
		end
		UiPop()
	end
end
