#include "kitt_constants.lua"

function init()
	t = 0

	kittInstanceId = 0
	kittInitialized = false
	BUTTONS_WIDTH = 93
	BUTTONS_HEIGHT = 190
	SCREEN_SEGMENT_WIDTH_HEIGHT = 190

	kittPlaySoundFileString = ""
	kittPlaySoundVuTypeString = ""
	kittMusicActionString = ""
	kittScreenModeLeftString = ""
	kittTTopLeftOpenString = ""
	kittTTopRightOpenString	= ""
	kittSilentModeString = ""
	kittEjectLeftActiveString = ""
	-- offset by the graphics drawing location
	kittButtonPositionsLeft = {
		{0,10,38,27}, {55,10,38,27};
		{0,48,38,27}, {55,48,38,27};
		{0,87,38,27}, {55,87,38,27};
		{0,125,38,27}, {55,125,38,27};
		{0,163,38,27}, {55,163,38,27};
	}
	kittButtonPositionsLeftState = {}
	for i=1, #kittButtonPositionsLeft do
		table.insert(kittButtonPositionsLeftState, false)
	end
	
	kittButtonPositionsRight = {
		{0,10,38,27}, {55,10,38,27};
		{0,48,38,27}, {55,48,38,27};
		{0,87,38,27}, {55,87,38,27};
		{0,125,38,27}, {55,125,38,27};
		{0,163,38,27}, {55,163,38,27};
	}
	kittButtonPositionsRightState = {}
	for i=1, #kittButtonPositionsRight do
		table.insert(kittButtonPositionsRightState, false)
	end

	kittButtonPositionsCenter = { 
		{0,10,39,27}, {50,10,39,27}, {101,10,39,27}, {151,10,39,27}; -- yup, I could generate all as rows and cols, and especially sizes are repeating
		{0,48,39,27}, {50,48,39,27}, {101,48,39,27}, {151,48,39,27};
		{0,86,39,27}, {50,86,39,27}, {101,86,39,27}, {151,86,39,27};
	}
	kittButtonPositionsCenterState = {}
	for i=1, #kittButtonPositionsCenter do
		table.insert(kittButtonPositionsCenterState, false)
	end
	kittMusicDialogPlayed = false
end

function draw()
	t = t + GetTimeStep()
	if not kittInitialized then
		kittInstanceId = GetBodyVehicle(GetShapeBody(GetScreenShape(UiGetScreen())))
		SetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SCREEN_CONTROLS, UiGetScreen())
		kittPlaySoundFileString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_PLAY_SOUND_FILE
		kittPlaySoundVuTypeString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_PLAY_SOUND_VUMETER_TYPE
		kittMusicActionString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_MUSIC_ACTION
		kittScreenModeLeftString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SCREEN_TV_LEFT .. KITT_GLOBAL_SCREEN_MODE

		kittTTopLeftOpenString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_JOINT_TTOP_LEFT .. KITT_GLOBAL_JOINT_ACTIVE
		kittTTopRightOpenString	= KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_JOINT_TTOP_RIGHT .. KITT_GLOBAL_JOINT_ACTIVE
		kittSilentModeString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SILENT_MODE
		kittEjectLeftActiveString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_EJECT_L .. KITT_GLOBAL_ACTIVE
		kittInitialized = true
	end
	if GetBool("savegame.mod.debugmode") then
		DebugWatch("kitt_screen_controls_instance_id", kittInstanceId)
	end
	
	if t > 10 then t = 0 end -- unused

	kitt_speed = GetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SPEEDOMETER_VALUE)
	
	UiPush()
		UiColor(1, 1, 1)
		UiImage("../ui/kitt_dash_s1_2_buttons_left.png")
		UiTranslate(SCREEN_SEGMENT_WIDTH_HEIGHT, 0)
		UiImage("../ui/kitt_dash_s1_2_buttons_center.png")
		UiTranslate(SCREEN_SEGMENT_WIDTH_HEIGHT*2 - BUTTONS_WIDTH, 0)
		UiImage("../ui/kitt_dash_s1_2_buttons_right.png")
	UiPop()

	UiPush()
		-- TODO: I want music player here at some point, but workshop might make it hard to work with
		UiTranslate(SCREEN_SEGMENT_WIDTH_HEIGHT * 1.5, SCREEN_SEGMENT_WIDTH_HEIGHT)
		UiAlign("center bottom")

		UiColor(1,0,0)
		UiFont("MOD/kitt/font/DSEG14Classic-Italic.ttf", 28)
		UiText("KNIGHT 2000")
	UiPop()

	-- so much wasted time, but it finally seems to work?
	UiPush()
		-- LEFT
		if InputPressed("lmb") then
			local pressedButtons = 0
			for i=1, #kittButtonPositionsLeft do
				local tempCoords = kittButtonPositionsLeft[i]
				UiPush()
					UiTranslate(tempCoords[1], tempCoords[2])
					if UiIsMouseInRect(tempCoords[3], tempCoords[4]) then
						kittButtonPositionsLeftState[i] = true
						pressedButtons = pressedButtons + 1
					else
						kittButtonPositionsLeftState[i] = false
					end
				UiPop()
			end

			if pressedButtons > 0 then
				UiSound("MOD/kitt/snd/kitt_button_press_short.ogg")

				if kittButtonPositionsLeftState[3] then -- SKI MODE
					SetString("hud.notification", "Work in progress, use Thrusters for now instead")
				end
				if kittButtonPositionsLeftState[4] then -- LASER
					SetString("hud.notification", "Coming when it's ready")
				end
				if kittButtonPositionsLeftState[5] then -- AUTO ROOF L
					SetBool(kittTTopLeftOpenString, not GetBool(kittTTopLeftOpenString))
				end
				if kittButtonPositionsLeftState[6] then -- MICRO JAM
					SetString("hud.notification", "Coming when it's ready")
				end
				if kittButtonPositionsLeftState[7] then -- SILENT MODE
					SetBool(kittSilentModeString, not GetBool(kittSilentModeString))
				end
				if kittButtonPositionsLeftState[9] then -- EJECT L
					-- SetString("hud.notification", "Coming when it's ready")
					if not GetBool(kittTTopLeftOpenString) then
						SetString(kittPlaySoundFileString, "autoroof_l_hint")
					else
						SetBool(kittEjectLeftActiveString, not GetBool(kittEjectLeftActiveString))
						if GetBool(kittEjectLeftActiveString) then
							SetString("hud.notification", "Ejection enabled. Select preferred direction using mouse and press [E] when ready") -- TODO: move it to the screen
						else
							SetString("hud.notification", "Ejection disabled") -- TODO: move it to the screen
						end
					end
					-- TODO: maybe auto-close roof after ejection?
				end
				if kittButtonPositionsLeftState[10] then -- LIC PLATE
					SetString("hud.notification", "I knew something was missing")
				end
			end
		end
	UiPop()
	
	UiPush()
		-- MIDDLE - HIDDEN
		UiTranslate(SCREEN_SEGMENT_WIDTH_HEIGHT,0)
		-- if UiIsMouseInRect(SCREEN_SEGMENT_WIDTH_HEIGHT,SCREEN_SEGMENT_WIDTH_HEIGHT) then
		if InputPressed("lmb") then
			local pressedButtons = 0
			for i=1, #kittButtonPositionsCenter do
				local tempCoords = kittButtonPositionsCenter[i]
				UiPush()
					UiTranslate(tempCoords[1], tempCoords[2])
					if UiIsMouseInRect(tempCoords[3], tempCoords[4]) then
						kittButtonPositionsCenterState[i] = true
						pressedButtons = pressedButtons + 1
					else
						kittButtonPositionsCenterState[i] = false
					end
				UiPop()
			end

			if pressedButtons > 0 then
				UiSound("MOD/kitt/snd/kitt_button_press_short.ogg")

				if kittButtonPositionsCenterState[1] then
					SetString(kittMusicActionString, KITT_GLOBAL_MUSIC_ACTION_SHOW_HIDE)
					if not kittMusicDialogPlayed and GetInt(kittScreenModeLeftString) ~= KITT_GLOBAL_SCREEN_MODE_MUSIC then
						SetString(kittPlaySoundFileString, "music_dialog")
						kittMusicDialogPlayed = true
					elseif kittMusicDialogPlayed and GetInt(kittScreenModeLeftString) ~= KITT_GLOBAL_SCREEN_MODE_MUSIC then
						SetString(kittPlaySoundFileString, "music_question")
					end
				end
				if kittButtonPositionsCenterState[2] then
					SetString(kittMusicActionString, KITT_GLOBAL_MUSIC_ACTION_PLAY_PAUSE)
				end
				if kittButtonPositionsCenterState[3] then
					SetString(kittMusicActionString, KITT_GLOBAL_MUSIC_ACTION_DOWN)
				end
				if kittButtonPositionsCenterState[4] then
					SetString(kittMusicActionString, KITT_GLOBAL_MUSIC_ACTION_UP)
				end
				if kittButtonPositionsCenterState[12] then
					SetString(kittPlaySoundFileString, "rnd01")
					SetInt(kittPlaySoundVuTypeString, 3)
				end
			end
		end
	UiPop()
	
	
	UiPush()
		-- RIGHT
		UiTranslate(SCREEN_SEGMENT_WIDTH_HEIGHT*3 - BUTTONS_WIDTH)
		if InputPressed("lmb") then
			local pressedButtons = 0
			for i=1, #kittButtonPositionsRight do
				local tempCoords = kittButtonPositionsRight[i]
				UiPush()
					UiTranslate(tempCoords[1], tempCoords[2])
					if UiIsMouseInRect(tempCoords[3], tempCoords[4]) then
						kittButtonPositionsRightState[i] = true
						pressedButtons = pressedButtons + 1
					else
						kittButtonPositionsRightState[i] = false
					end
				UiPop()
			end

			if pressedButtons > 0 then
				UiSound("MOD/kitt/snd/kitt_button_press_short.ogg")

				if kittButtonPositionsRightState[1] then -- TURBO BOOST
					SetString("hud.notification", "Work in progress, it's not trivial apparently")
				end
				if kittButtonPositionsRightState[6] then -- AUTO ROOF R
					SetBool(kittTTopRightOpenString, not GetBool(kittTTopRightOpenString))
				end
				if kittButtonPositionsRightState[7] then -- GRPLG. HOOK
					SetString("hud.notification", "Coming when it's ready")
				end
				if kittButtonPositionsRightState[8] then -- OIL SLICK
					SetString("hud.notification", "Coming when it's possible")
				end
				if kittButtonPositionsRightState[10] then -- EJECT R
					SetString("hud.notification", "Coming when it's ready")
				end
			end
		end
	UiPop()
end