#include "kitt_constants.lua"

function init()
	t = 0

	

	
	-- KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL = "rv.kitt.vumeter.level"
	-- status, err = pcall(UiGetScreen)
	
	-- if (not status) then
    --     DebugPrint("LUA ERROR: " .. err);
	-- end
	
	scrWidth = 500 --UiWidth()
	scrHeight = 500 --UiHeight()
	
	kitt_vu_bar_height_divider = scrHeight/(2*17*6)
	kitt_vu_bar_height_segment = kitt_vu_bar_height_divider*5
	kitt_vu_bar_width_unit = scrWidth/(2*3*3)
	kitt_vu_bar_width_segment = kitt_vu_bar_width_unit*2
	-- DebugWatch("UiWidth", UiWidth())
	-- DebugWatch("UiHeight", UiHeight())
	kitt_vu_meter_multipliers_center = {0, 0.125, 0.25, 0.375, 0.5, 0.625, 0.75, 0.875, 1}
	
	currentVuMeterLevel = 0.0

	kitt_vu_meter_min_color_value = 0.075
	kittVUColors = { -- min, max, KARR display mode, sides multiplier
		[1]= { {kitt_vu_meter_min_color_value, 0, 0}, {1, 0, 0}, false, 0.5};
		[2]= { {kitt_vu_meter_min_color_value*0.6, kitt_vu_meter_min_color_value, 0}, {0.6, 1, 0}, true, 0.9 };
		[3]= { {0, 0, kitt_vu_meter_min_color_value}, {0.2, 0.5, 1}, false, 0.5};
	}
	kittInstanceId = 0
	kittInitialized = false
	-- kitt_engine_mode = GetString(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_ENGINE_MODE)
	-- kittCurrentVUColor = GetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_TYPE)
end

function getParentVehicle()
	return GetBodyVehicle(GetShapeBody(GetScreenShape(UiGetScreen())))
end
	
function writeCruiseMode(str1, str2)
	UiPush()
		UiColor(0,0,0)
		UiFont("bold.ttf",30)
		-- UiTranslate(100,10)
		UiTranslate(UiCenter()/2,12)
		UiAlign("center")
		UiText(str1)
		UiTranslate(0,25)
		UiText(str2)
	UiPop()
end

function getVUmeterColorValue(segmentNum, vulevel, side)
	local modeData = kittVUColors[kittCurrentVUColor]

	-- calculate current segment
	if segmentNum > 9 then
		segmentNum = 10 - (segmentNum % 9)
	end
	if side and modeData[3] then
		segmentNum = 10 - segmentNum
	end
	local color = 0
	if side then
		vulevel = vulevel * modeData[4]
	end

	local thresholdForCurrentSegment = kitt_vu_meter_multipliers_center[10-segmentNum]
	local prevSegColor = 0
	if vulevel > thresholdForCurrentSegment then
		color = math.max(0,math.min(1, (vulevel-thresholdForCurrentSegment)*8))
	elseif segmentNum < 9 and vulevel+0.125 > thresholdForCurrentSegment then -- for previous segment
		prevSegColor = math.max(0,math.min(1, ((vulevel+0.125)-thresholdForCurrentSegment)*8))
		if prevSegColor > 0.01 then
			color = prevSegColor * 0.3
		end
	end
	return color
end


function getVUmeterColorValueSides(segmentNum, vulevel)
	return getVUmeterColorValue(segmentNum, vulevel, true)
end

function computeVuColor(colorLevel)
	local temp = kittVUColors[kittCurrentVUColor]
	return {
		math.max(temp[1][1],temp[2][1] * colorLevel);
		math.max(temp[1][2],temp[2][2] * colorLevel);
		math.max(temp[1][3],temp[2][3] * colorLevel);
	}
end


function draw()
	if not kittInitialized then
		kittInstanceId = GetBodyVehicle(GetShapeBody(GetScreenShape(UiGetScreen())))
		kittInitialized = true
	end
	if GetBool("savegame.mod.debugmode") then
		DebugWatch("kitt_screen_main_instance_id", kittInstanceId)
		DebugWatch("UiGetScreen",UiGetScreen())
		DebugWatch("GetScreenShape",GetScreenShape(UiGetScreen()))
		DebugWatch("GetShapeBody",GetShapeBody(GetScreenShape(UiGetScreen())))
		DebugWatch("getParentVehicle",getParentVehicle())
		-- DebugWatch("parentVehicleId",GetTagValue(getParentVehicle(),"id"))
	end
	t = t + GetTimeStep()
	if t > 45 then t = 0 end
	globalVUMeterLevel = GetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL)
	if globalVUMeterLevel >= currentVuMeterLevel then
		currentVuMeterLevel = globalVUMeterLevel
		SetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL, 0.0) -- FIXME: this will bite me in the a$$ later, need to move it at least to kitt.lua to allow more than one VUmeter event receiver to work with this
	else
		currentVuMeterLevel = math.max(currentVuMeterLevel - 0.1, 0)
	end

	-- for i=1, 17 do
	-- 	DebugWatch("VUTEST"..i, getVUmeterColorValue(i, currentVuMeterLevel))
	-- end

	-- initialize screen
	kittCurrentVUColor = GetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_TYPE)
	UiPush()
		UiColor(0,0,0)
		UiRect(scrWidth, scrHeight)
		-- UiColor(1*(t/45),0,0)

		-- KITT VU meter
		UiTranslate(UiCenter()/2, scrHeight/32)
		-- UiColor(GetFloat(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_VUMETER_LEVEL),0,0) - initial
		UiTranslate(kitt_vu_bar_width_unit/2, 0)
		UiPush()
			for i=1, 17 do
				local color = getVUmeterColorValueSides(i, currentVuMeterLevel)
				local colorArr = computeVuColor(color)
				UiColor(colorArr[1], colorArr[2], colorArr[3])
				UiRect(kitt_vu_bar_width_segment, kitt_vu_bar_height_segment)
				UiTranslate(0, kitt_vu_bar_height_divider+kitt_vu_bar_height_segment)
			end
		UiPop()
		
		UiPush()
			UiTranslate(kitt_vu_bar_width_unit*3, 0)
			for i=1, 17 do
				local color = getVUmeterColorValue(i, currentVuMeterLevel)
				local colorArr = computeVuColor(color)
				UiColor(colorArr[1], colorArr[2], colorArr[3])
				UiRect(kitt_vu_bar_width_segment, kitt_vu_bar_height_segment)
				UiTranslate(0, kitt_vu_bar_height_divider+kitt_vu_bar_height_segment)
			end
		UiPop()
		
		UiPush()
			UiTranslate(kitt_vu_bar_width_unit*6, 0)
			for i=1, 17 do
				local color = getVUmeterColorValueSides(i, currentVuMeterLevel)
				local colorArr = computeVuColor(color)
				UiColor(colorArr[1], colorArr[2], colorArr[3])
				UiRect(kitt_vu_bar_width_segment, kitt_vu_bar_height_segment)
				UiTranslate(0, kitt_vu_bar_height_divider+kitt_vu_bar_height_segment)
			end
		UiPop()
		-- UiTranslate(0, scrHeight/32)
	UiPop()


	kitt_engine_mode = GetString(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_ENGINE_MODE)
	UiPush()
		UiTranslate(UiCenter()/2, scrHeight/32)
		UiTranslate(0, scrHeight/32)
		-- UiColor(1,0,0)
		-- UiRect(250, 250)

		-- dashboard elements
		
		-- auto mode
		UiTranslate(0, scrHeight/2)
		
		if kitt_engine_mode == KITT_GLOBAL_ENGINE_MODE_AUTO then
			UiColor(1.0, 0.525490196, 0.215686275) -- ON
		else
			UiColor(0.160784314, 0.082352941, 0.035294118) -- OFF
		end

		UiRect(scrWidth/2, scrHeight/8)
		UiTranslate(0, scrHeight/32)
		writeCruiseMode("AUTO","CRUISE")

		-- normal mode
		UiTranslate(0, scrHeight/8)
		if kitt_engine_mode == KITT_GLOBAL_ENGINE_MODE_NORMAL then
			UiColor(0.933333333, 0.968627451, 0.02745098) -- ON
		else
			UiColor(0.149019608, 0.156862745, 0.031372549) -- OFF
		end


		UiRect(scrWidth/2, scrHeight/8)
		UiTranslate(0, scrHeight/32)
		writeCruiseMode("NORMAL","CRUISE")
		
		-- pursuit mode
		UiTranslate(0, scrHeight/8)
		if kitt_engine_mode == KITT_GLOBAL_ENGINE_MODE_PURSUIT then
			UiColor(0.090196078, 0.294117647, 0.956862745) -- ON
		else
			UiColor(0.015686275, 0.043137255, 0.149019608) -- OFF
		end

		UiRect(scrWidth/2, scrHeight/8)
		UiTranslate(0, scrHeight/32)
		writeCruiseMode("PURSUIT","MODE")
	UiPop()
end


-- BS function below. I got lost in my own reasoning
-- function getVUmeterColorValue(segmentNum, vulevel)
-- 	-- calculate current segment
-- 	if segmentNum > 9 then
-- 		segmentNum = 10 - (segmentNum % 9)
-- 	end
-- 	local color = 0
-- 	local thresholdForCurrentSegment = (1-kitt_vu_meter_multipliers_center[segmentNum])
-- 	-- DebugPrint(thresholdForCurrentSegment)
-- 	if (vulevel > thresholdForCurrentSegment) then
-- 		color = 1
-- 	elseif vulevel>0 and (vulevel < thresholdForCurrentSegment+0.125) then -- if value doesn't fit into the next segment "max"
-- 		-- color = 0.3
-- 		color = math.max(0, ((thresholdForCurrentSegment-vulevel)*8)
-- 	elseif vulevel>0 and (vulevel+0.250 > thresholdForCurrentSegment) then
-- 		color = math.min(1, (vulevel+0.25-thresholdForCurrentSegment)*3)
-- 	-- elseif vulevel>0 and (vulevel+0.375 > thresholdForCurrentSegment) then
-- 	-- 	color = 0.1
-- 	else
-- 		color = 0
-- 	end
-- 	-- local color = currentVuMeterLevel*>itt_vu_meter_multipliers_center[i]
-- 	DebugWatch("VUTEST"..segmentNum, "vulevel "..vulevel.." thrsForCurrSeg "..thresholdForCurrentSegment.." vulvl+0.125 "..(vulevel+0.125).." vulvl-thrs4CurrSeg "..((vulevel-thresholdForCurrentSegment)))
-- 	return color
-- end