#include "kitt_constants.lua"

function init()
	t = 0
	msgCenterTimer = 0
	msgCenterIndex = 0
	msgCenterTexts = {
		"CALIBRATE";
		"L. TURBINE";
		"R. TURBINE";
		"MASS FLOW";
		"FUEL FLOW";
		"OIL PRESS";
		"VOLTS";
		"AMPS";
		"INLET TEMP";
		"INT TEMP";
		"EXT TEMP";
		"EXH TEMP";
		"RANGE MILE";
		"BOOST LBS";
		"FT IMAGING";
		"LATITUDE";
		"LONGITUDE";
		"HEADING";
		"SATELLITE";
		"LASER AIM";
		"LASER FIRE";
		"CRUISE CTL";
		"AUTO MODE";
		"TURBO MODE";
		"EJT LEFT";
		"EJT RIGHT";
		"SYNTHESIZE";
		"AUTO ROOF";
		"OXYGEN";
		"OVERRIDE";
		"OILSLICK";
		"AUTOSCAN";
		"RADAR";
		"HARMONICS";
		"BLOOD ANLY";
		"DNA";
		"AUTO SUCK";
		"AUTO CAL";
		"PRESS IND.";
		"ACCY VOLTS";
		"FUEL RESRV";
		"FUEL PRESS";
		"TURBINE OK";
		"RPM SET";
		"DEG INC";
		"IAT RDG";
		"EXT PRESS";
		"EXH PRESS";
		"PRESS MB";
		"SHUTE TEST";
		"SHUTE OK";
		"MAIN PRESS";
		"MAIN ENG";
	}
	msgCenterTextsExploded = {}
	for i=1, #msgCenterTexts do
		table.insert(msgCenterTextsExploded, stringExplode(msgCenterTexts[i]))
	end

	kittInstanceId = 0
	kittInitialized = false
end

function stringExplode(inputstr)
	local t={}
	for i=1, #inputstr do
		local str = string.sub(inputstr,i,i)
		table.insert(t, str)
	end
	return t
end

function draw()
	t = t + GetTimeStep()
	if not kittInitialized then
		kittInstanceId = GetBodyVehicle(GetShapeBody(GetScreenShape(UiGetScreen())))
		kittInitialized = true
	end
	if GetBool("savegame.mod.debugmode") then
		DebugWatch("kitt_screen_rpm_instance_id", kittInstanceId)
	end
	
	if t > 45 then t = 0 end
	if msgCenterTimer > 0 then
		msgCenterTimer = msgCenterTimer - 1
	else
		msgCenterTimer = 120
		msgCenterIndex = (msgCenterIndex + 1) % #msgCenterTexts
	end
	-- DebugWatch("msgCenterTimer", msgCenterTimer)
	-- DebugWatch("msgCenterIndex", msgCenterIndex)

	kitt_speed = GetInt(KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SPEEDOMETER_VALUE)
	UiPush()
		bar_multiplier = math.floor(math.min(kitt_speed, 200) / 10) / 20
		UiTranslate(42,20)
		-- background bar
		UiColor(0.207843137, 0.015686275, 0.015686275)
		UiRect(180,8)
		-- speed bar
		UiColor(1, 0, 0)
		UiRect(180 * bar_multiplier,8)
		-- UiRect(180,8)
	UiPop()
	UiPush()
		UiColor(1, 1, 1)
		-- UiImage("MOD/kitt/ui/kitt_dash_s1_2_speed_meter.png")
		UiImage("../ui/kitt_dash_s1_2_speed_meter_blank.png")
	UiPop()

	UiPush()
		-- UiTranslate(60, 72)
		UiTranslate(55, 72)
		UiColor(1,0,0)
		UiFont("MOD/kitt/font/DSEG7Classic-Italic.ttf", 28)
		-- UiText("609")
		speed = kitt_speed
		digit1 = speed % 10
		speed = math.floor(speed / 10)
		digit2 = speed % 10
		speed = math.floor(speed / 10)
		digit3 = speed % 10
		-- DebugWatch("digit1",digit1)
		-- DebugWatch("digit2",digit2)
		-- DebugWatch("digit3",digit3)

		UiText(digit3 .. " " .. digit2 .. " " .. digit1)
	UiPop()
	
	UiPush()
		UiTranslate(41, 146)
		UiColor(0.078431373, 0.847058824, 0.8)
		UiFont("MOD/kitt/font/DSEG14Classic-Italic.ttf", 16)
		
		for i=1, #msgCenterTextsExploded[msgCenterIndex+1] do
			UiText(msgCenterTextsExploded[msgCenterIndex+1][i])
			UiTranslate(19,0)
		end
	UiPop()
end