#include "kitt_constants.lua"
#include "kitt_music_list.lua"
function init()
	t = 0
	kittInstanceId = 0
	kittInitialized = false
	KITT_OUTLINE_IMG = "MOD/kitt/ui/kitt_outline_nobg_30.png"

	KITT_FONT_LCD_FULLTEXT = "MOD/kitt/font/DSEG14Classic-Italic.ttf"
	KITT_FONT_LCD_FULLTEXT_BOLD = "MOD/kitt/font/DSEG14Classic-Bold.ttf"
	KITT_FONT_REGULAR = "regular.ttf"
	KITT_FONT_BOLD = "bold.ttf"
	
	KITT_OUTLINE_W, KITT_OUTLINE_H = UiGetImageSize(KITT_OUTLINE_IMG)
	kittScreenMode = KITT_GLOBAL_SCREEN_MODE_OVERVIEW
	KITT_MUSIC_UI_ROW_HEIGHT = 22
	kittMusicUiSelectedElement = 0
	kittMusicStatePlaying = false
	kittMusicPlayedTrack = 0

	kittScreenModeString = ""
	kittMusicActionString = ""
	kittMusicListVisibleTopElement = 0
	kittMusicListVisibleElementsCount = 9 -- TODO: compute it, maybe?
end

function draw()
	t = t + GetTimeStep()
	if t > 10 then t = 0 end

	if not kittInitialized then
		kittInstanceId = GetBodyVehicle(GetShapeBody(GetScreenShape(UiGetScreen())))
		kittMusicActionString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_MUSIC_ACTION
		kittScreenModeString = KITT_GLOBAL_PREFIX .. kittInstanceId .. KITT_GLOBAL_SCREEN_TV_LEFT .. KITT_GLOBAL_SCREEN_MODE
		kittInitialized = true
	end
	-- DebugWatch("kittMusicUiSelectedElement", kittMusicUiSelectedElement)
	-- DebugWatch("kittMusicListVisibleTopElement", kittMusicListVisibleTopElement)
	kittScreenMode = GetInt(kittScreenModeString)

	-- mindf**k below, but it was written at 3AM
	if kittScreenMode ~= KITT_GLOBAL_SCREEN_MODE_MUSIC then
		if GetInt(kittMusicActionString) == KITT_GLOBAL_MUSIC_ACTION_SHOW_HIDE then
			SetInt(kittScreenModeString, KITT_GLOBAL_SCREEN_MODE_MUSIC)
			kittScreenMode = KITT_GLOBAL_SCREEN_MODE_MUSIC
		end
		-- not to react on music screen enter if something was clicked while not in music mode
		SetInt(kittMusicActionString, KITT_GLOBAL_MUSIC_ACTION_NONE)
	end

	if kittScreenMode == KITT_GLOBAL_SCREEN_MODE_OVERVIEW then
		UiColor(.1, 0.08, 0.06)
		UiRect(UiWidth(), UiHeight())

		UiPush()
			UiTranslate(UiWidth()/2-KITT_OUTLINE_W/2, UiHeight()/2-KITT_OUTLINE_H/2)
			UiColor(1, 1, 1)
			UiImage(KITT_OUTLINE_IMG)
		UiPop()

		UiPush()
			UiTranslate(UiWidth()/2, UiHeight()-30)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			-- UiColor(.1, 0.08, 0.06)
			UiFont(KITT_FONT_LCD_FULLTEXT, 22)
			UiText("INTEGRITY   100%")
		UiPop()

	elseif kittScreenMode == KITT_GLOBAL_SCREEN_MODE_MUSIC then
		-- handle input first
		local musicAction = GetInt(kittMusicActionString)
		SetInt(kittMusicActionString, KITT_GLOBAL_MUSIC_ACTION_NONE)
		if musicAction == KITT_GLOBAL_MUSIC_ACTION_SHOW_HIDE then
			SetInt(kittScreenModeString, KITT_GLOBAL_SCREEN_MODE_OVERVIEW)
		
		elseif musicAction == KITT_GLOBAL_MUSIC_ACTION_PLAY_PAUSE then

			-- DebugPrint(KITT_MUSIC_LIST[kittMusicUiSelectedElement+1][2])
			
			if KITT_MUSIC_LIST[kittMusicUiSelectedElement+1][2] == KITT_PLAYER_ACTIONS_OPEN_CUSTOM_MUSIC_FOLDER then
				Command("game.openfolder", GetString("mods.available.".. GetString("game.mod") ..".path").."/kitt/custom_music")
			elseif kittMusicStatePlaying and (kittMusicPlayedTrack == kittMusicUiSelectedElement + 1) then
				kittMusicStatePlaying = false
				-- DebugPrint("Stop Music")
				StopMusic()
			else
				kittMusicStatePlaying = true
				-- DebugPrint("Start Music " .. KITT_MUSIC_LIST_DIRECTORY .. KITT_MUSIC_LIST[kittMusicUiSelectedElement+1][2])
				kittMusicPlayedTrack = kittMusicUiSelectedElement + 1
				PlayMusic(KITT_MUSIC_LIST[kittMusicPlayedTrack][2])
				-- PlayMusic(KITT_MUSIC_LIST_DIRECTORY .. KITT_MUSIC_LIST[kittMusicUiSelectedElement+1][2])
			end
		
		elseif musicAction == KITT_GLOBAL_MUSIC_ACTION_DOWN then
			if kittMusicUiSelectedElement + 1 >= #KITT_MUSIC_LIST then
				kittMusicUiSelectedElement = #KITT_MUSIC_LIST-1
			else
				kittMusicUiSelectedElement = kittMusicUiSelectedElement + 1
			end
			if kittMusicUiSelectedElement > kittMusicListVisibleTopElement + (kittMusicListVisibleElementsCount-1) then
				kittMusicListVisibleTopElement = kittMusicListVisibleTopElement + 1
			end
		
		elseif musicAction == KITT_GLOBAL_MUSIC_ACTION_UP then
			if kittMusicUiSelectedElement - 1 <= 0 then
				kittMusicUiSelectedElement = 0
			else
				kittMusicUiSelectedElement = kittMusicUiSelectedElement - 1
			end
			if kittMusicUiSelectedElement < kittMusicListVisibleTopElement then
				kittMusicListVisibleTopElement = kittMusicListVisibleTopElement - 1
			end
		end
			

		-- now draw
		UiColor(.1, 0.08, 0.06)
		UiRect(UiWidth(), UiHeight())
		UiAlign("top left")
		-- DebugPrint(#KITT_MUSIC_LIST)
		UiPush()
			UiTranslate(0, 33 - (kittMusicListVisibleTopElement * KITT_MUSIC_UI_ROW_HEIGHT))
			
			-- Cursor
			UiPush()
				UiTranslate(0, 10 + kittMusicUiSelectedElement * KITT_MUSIC_UI_ROW_HEIGHT)
				UiColor(0, 0.2, 0)
				UiRect(UiWidth(), KITT_MUSIC_UI_ROW_HEIGHT)
			UiPop()
			
			-- Texts
			UiPush()
				UiTranslate(10,10)
				for i=1, #KITT_MUSIC_LIST do
					UiColor(1, 1, 1)
					UiFont(KITT_FONT_REGULAR, 20)
					UiText(KITT_MUSIC_LIST[i][1])
					UiTranslate(0,KITT_MUSIC_UI_ROW_HEIGHT)
				end
			UiPop()
		UiPop()
		-- now draw top bar
		UiPush()
			UiColor(0,0.8,0)
			UiRect(UiWidth(), 40)

			UiTranslate(10,7)
			-- UiColor(1,1,1)
			UiColor(.1, 0.08, 0.06)
			UiFont(KITT_FONT_LCD_FULLTEXT_BOLD, 18)
			UiText("Default Playlist (".. #KITT_MUSIC_LIST ..")")
		UiPop()
	end
end

